import os

CONFIG_DIR = os.path.expanduser('~/.skeletor')
CONFIG_FILE = os.path.join(CONFIG_DIR, "skeletor.conf")

RESOURCE_DIR='data'
RESOURCE_ZIP='data.gz'

# There may be other scopes ("profile"?) but they are
# not implicitly searched
TEMPORARY, PLUGIN, PROJECT, WORLD = 'temporary', 'plugin', 'project', 'world'

# SCOPES are searched left to right, these names act as keys in a
# mapping. such that scopes[PROJECT] will yield the current projects
# path into the configuration file.
#
SCOPE_PRECEDENCE = (TEMPORARY, PROJECT, PLUGIN, WORLD)
CONFIG_ROOT = "skeletor"

# plugin entry point namespaces for skeletor
PROFILE_NS='skeletor.profile'
DEFAULT_NS='skeletor.default'


