from skeletor.plugin import Plugin, Command
#from skeletor.model import Project
from skeletor.utils import getModule
import skeletor.widgets as widgets
import skeletor.template as template
import os

DATA = 'plugins/tool_data'

class Tool(Base):
    """Add a tool to a project"""
    __name__= "tool"

    def commands(self, commands):
        commands['add_tool'] = Command('add_tool', self.create,
                 """Add a tool to the base project""")

    def LoadData(self, project):
        Base.LoadData(self, project)
        self.loadTemplates(self.templates, DATA)

        # initialize tool when product is initialized
        init = self.templates[os.path.join(['__init__.py'])]
        init.getSlotByName('InitializeTool').fill(template.PythonTemplate("""import tools
cmf_utils.ToolInit(
    "%s Tool" % config.PROJECTNAME,
    tools = (
        ,#{ToolName,code,insertBefore}#
        ),
    product_name = config.PROJECTNAME,
    icon = "tool.gif",
    ).initialize( context )"""))

        # make sure the tool is created
        test = self.templates[os.path.join(['tests', 'test_project.py'])]
        test.getSlotByName('ProjectTest').fill(template.PythonTemplate("""
    def test_#{ToolId,code,replace}#(self):
        tool = getToolByName(self.portal, '#{ToolId,code,replace}#')
        assert tool"""))
                          
        # make the tool available via import
        test = self.templates[os.path.join(['tools', '__init__.py'])]
        test.getSlotByName('ToolImport').fill(template.PythonTemplate("""import #{ToolClass,code,replace}#"""))

    def LoadConfig(self, project):
        self.addQuestion(self,
                         widgets.entry,
                         "Tool name?",
                         "ToolName")

        self.addQuestion(self,
                         widgets.entry,
                         "Tool class name?",
                         self.recordClassName)

    def recordClassName(self, result):
        self.properties['ToolClassName'] = result
        self.properties['ToolClassPath'] = 'Products.'+self.engine.options.ProjectName+'.tools.'+result
