import popen2
import os
import signal

class Process:
    """Very Simple model of a process.

    This can be replaced in Python2.4 with subprocess.call I think

    >>> p = Process('echo "Hello World"')
    >>> p = Process('ls')
    >>> assert p.read() # the result of running ls
    """

    def __init__(self, cmd, bufsize=0):
        self._p = popen2.Popen3(cmd, False, bufsize)

    def __del__(self):
        if not hasattr(self, "_p"): return
        if self._p and self._p.poll() == -1:
            self._p.tochild.close()
            self._p.fromchild.close()
        if self._p and self._p.poll() == -1:
            os.kill(self._p.pid, signal.SIGTERM)

    def write(self, msg): self._p.tochild.write(msg)
    def read(self, size=None):
        if size:
            self._p.fromchild.read(size)
        return self._p.fromchild.read()

    def wait(self): return self._p.wait()
    def wclose(self): self._p.tochild.close()
    def rclose(self): self._p.fromchild.close()
    def close(self): self.wclose();self.rclose()

def Command(cmd):
    c = Process(cmd)
    d = c.read()
    c.close()
    return d


