import os
import zipfile
import unittest
import utils
import tempfile
import inspect as ins
import config
import sys
import cStringIO

pjoin = os.path.join
here = os.path.dirname(__file__)
class TestSetup(unittest.TestCase):

    def test_zipcreated(self):
        # make sure pysafe zips are created
        pdir = pjoin(here, 'plugins')
        assert os.path.exists(pjoin(pdir, 'base', config.RESOURCE_ZIP))
        assert os.path.exists(pjoin(pdir, 'content', config.RESOURCE_ZIP))

    def test_makezip(self):
        out = cStringIO.StringIO()
        tstr = 'wheeeeeeeeee'
        ignore='ignorethis'
        targetdir = tempfile.mkdtemp('skeletor-test-target')
        tdir = pjoin(targetdir, ignore)

        testf = open(pjoin(targetdir, tstr), 'w')
        testf.close()

        zipname = 'the.zip'
        
        fullname=pjoin(os.path.abspath(os.path.dirname(__file__)), 'tests')
        zfile=utils.unlink(pjoin(fullname, zipname))
        zippy = utils.make_zip(targetdir, fullname, zipname, ignore=lambda name: name.find(ignore)>-1)
        assert os.path.exists(fullname)
        zippy = zipfile.ZipFile(zfile, 'r')
        offset = os.path.dirname(targetdir).count(os.path.sep) +1
        assert utils.offsetpath(pjoin(targetdir, tstr), offset) in zippy.namelist()
        oldout = sys.stdout
        sys.stdout = out
        zippy.printdir()
        assert out.getvalue().find(ignore) == -1
        sys.stdout = oldout

def suite():
    return unittest.makeSuite(TestSetup)

if __name__ == '__main__':
    unittest.main()
