# python 2.4
#from subprocess import Popen
from process import Command
import datetime

## UI "Widgets"
def entry(plugin, str, default='', required=True):
    """ask a question, return the result"""
    result = None
    while not result:
        if plugin.engine.options.display == "zenity":
            result = Command('zenity --entry --entry-text "%s" --title "%s" --text "%s"' % (default, str, str))
        else:
            result = raw_input(str + " [%r]?" % default)
            if not result: result=default

        if result or not required: break

    return result.strip()

def fileselect(plugin, str, default='', directory=0):
    """ask a question, return the result"""
    result = None

    if directory:
        directory = "--directory"
    else:
        directory = ''

    while not result:
        if plugin.engine.options.display == "zenity":
            result = Command('zenity --file-selection %s --title "%s"' % (directory, str))
        else:
            result = raw_input("%s[%r]?" % (str, default))
            if not result: result=default

        if result: break

    return result.strip()

def checkbox(plugin, str, **kwargs):
    """ask a question, return the result"""
    result = None
    choices = kwargs['options']
    column = kwargs['column']
    ltype = kwargs.get("type", "checklist")
    single = kwargs.get("single", False)

    optionstr = "FALSE " + " FALSE ".join(choices)

    while not result:

        if plugin.engine.options.display == "zenity":
            if single: ltype = "radiolist"
            cmd = '''zenity --list --%s --title "%s" --column "Select" --column "%s" %s''' % (
                ltype,
                str,
                column, optionstr)


            result = Command(cmd)
        else:
            print "Enter values delimited by '|'"
            result = raw_input("%s[%r]?" % (str, '|'.join(choices)))

        if result: break

    result = result.split('|')
    result = [r.strip() for r in result]
    if single: result = result[0]
    return result


def date(plugin, str, default=None, required=True):
    result = None
    if not default:
        now = datetime.datetime.now()
        default = now.strftime("%m/%d/%Y")

    while not result:
        if plugin.engine.options.display == "zenity":
            result = Command('zenity --calendar --text "%s"' % (str))
        else:
            result = raw_input(str + " [%r]?" % default)
            if not result: result=default

        if result or not required: break

    return result.strip()
